#include <bits/stdc++.h>

#define int long long int
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()

using namespace std;

signed main()
{   ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n,q;
    cin >> n >> q;
    while(q--){
        int a,b,c;
        cin >> a >> b >> c;
        if(a==1){
            char d;
            cin >> d;
        }else{
            cout << 1 << endl;
        }
    }
    return 0;
}